Attribute VB_Name = "WorkSheetFunction"
'***Alle APIs instanzieren
Private Declare Function GetWindowThreadProcessId Lib "user32.dll" (ByVal hWnd As Long, lpdwProcessId As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long

'***alle bentigen Konstanten
Public lTaskID As Long
Const PROCESS_TERMINATE = &H1
Const GW_HWNDFIRST = 0
Const GW_HWNDLAST = 1
Const GW_HWNDNEXT = 2
Const GW_HWNDPREV = 3
Const GW_OWNER = 4
Const GW_CHILD = 5
Const GW_MAX = 5
Const GWL_STYLE = (-16)
Const WS_VISIBLE = &H10000000
Const WS_BORDER = &H800000

Sub CATMain()

    'Excel Objekt erstellen
    Dim Excel As Object
    Set Excel = GetMyExcel
    
    'nderungen in Excel durchfhren
    ReadExcelEntries Excel
    
    'Excel Object zerstren
    killExcelInstanceById Excel

End Sub

Private Function GetMyExcel() As Object
    On Error Resume Next
    'Auf laufende Instanz zuugreifen wenn mglich
    Set GetMyExcel = GetObject(, "Excel.Application")
    'Wenn keine laufende Instanz gefunden wird
    If Err.Number <> 0 Then
        Err.Clear
        'Ein Excel Objekt erstellen
        Set GetMyExcel = CreateObject("Excel.Application")
        If Err.Number <> 0 Then
            'Wenn keine Verbindung zu Excel aufgebaut werden kann
            Dim Box As String
            Box = MsgBox("Es konnte keine Verbindung zu Excel aufgebaut werden!" + Chr(10) + _
                        "Das Makro wird beendet", vbCritical, "Keine Excelverbindung")
            Err.Clear
            End
        End If
    End If
End Function

'***Auslesen des Fensterhandles
Private Function GetWindowTaskID(ByVal hWnd As Long) As Long
    Dim lResult As Long
    Dim lTemp As Long
 
    'Fensterhandle wird ber Caption ausgelesen
    lResult = GetWindowThreadProcessId(hWnd, lTemp)
    GetWindowTaskID = lTemp
End Function

'***Hier wird der Prozess zerstrt
Private Sub TerminateTaskID(lTaskID As Long)
    Dim hTask As Long
    Dim lResult As Long
   
    'Zugriff aus Prozess
    hTask = OpenProcess(PROCESS_TERMINATE, 0&, lTaskID)
    
    'Prozess zerstren
    lResult = TerminateProcess(hTask, 1&)
    
    'Handle schlieen
    lResult = CloseHandle(hTask)
End Sub

'***Excel Prozess zerstren
Function killExcelInstanceById(ByVal myExcelApp As Object)
    'Excel Fenstername auslesen
    Dim myExcelName As String
    myExcelName = myExcelApp.Caption
    
    'Aufruf der Funktion zum beenden des Prozesses
    'Hierbei wird der Fenstername bergeben.
    'Mit Hilfe des Fensternamens wird der zu beendende Handle zum Prozess ausgelesen
    TerminateTaskID GetWindowTaskID(FindWindow(vbNullString, myExcelName))
End Function

Private Function ReadExcelEntries(ByRef Excel As Object)

    Dim iWorkbooks As Object
    Dim iWorkbook As Object
    Dim iWorksheets As Object
    Dim iWorksheet As Object
    Dim myCollection As New Collection

    Set iWorkbooks = Excel.Workbooks
    Excel.Workbooks.Open Filename:="C:\Dokumente und Einstellungen\frauendan\Desktop\Testdatei.xls"
    Set iWorkbook = iWorkbooks.Item(iWorkbooks.Count)
    Set iWorksheets = iWorkbook.Worksheets
    Set iWorksheet = iWorksheets.Item(1)
    
    Excel.Visible = True
    
    'Einstellung der Zeile ab welcher Excel den Vergleich anfngt
    Dim lngZeile As Long
    
    'Einstellung der Spalte deren Zellen Excel vergelichen soll
    Dim lngCol As Long
    lngCol = 2
 
    'Vergleich
    For lngZeile = 2 To iWorksheet.Cells(iWorksheet.Rows.Count, lngCol).End(-4162).Row
        If Excel.WorkSheetFunction.CountIf(iWorksheet.Range(iWorksheet.Cells(2, lngCol), iWorksheet.Cells(lngZeile, lngCol)), iWorksheet.Cells(lngZeile, lngCol)) = 1 Then
            'Hinzufgen zu einer Collection
            myCollection.Add iWorksheet.Cells(lngZeile, lngCol).Formula
        End If
    Next lngZeile
    
    'Autofilter einstellen
    Excel.Range("A1").AutoFilter Field:=1, Criteria1:="3"

End Function

